from skidl import *

# set KICAD_SYMBOL_DIR=D:\Apps\KiCad_Plugins\kicad-symbols
# Capacitor_THT:CP_Radial_Tantal_D9.0mm_P5.00mm
# apa-106:APA-106-F8 === show('apa-106', 'APA-106')
#  apa1[2] += v_in
#  apa2[1] += apa1[4]
# Create input & output voltages and ground reference.
vin, vout, gnd = Net('VI'), Net('VO'), Net('GND')

# APAs
apa = []
dcap =[]

### First C
for x in range(0,20):
    apa.append(Part('apa-106', 'APA-106', footprint='apa-106:APA-106-F8'))
    #Decoupling Cap
    dcap.append(Part('Device', 'CP', footprint='Capacitor_SMD:C_0805_2012Metric'))
    dcap[-1].ref = "CP" + str(x+1)
    vin += dcap[-1][1]
    gnd += dcap[-1][2]

    apa[x][2] += vin
    apa[x][3] += gnd
    # link D-In to D-Out of previous pixel
    if x > 0:
        apa[x][1] += apa[x-1][4]

resistor = Part('Device', 'R', footprint='Resistor_SMD:R_1206_3216Metric')
din = Part('Connector', 'TestPoint', footprint='Connector_Wire:SolderWirePad_1x01_SMD_5x10mm')
din.ref = "D-IN"
resistor[2] += din[1]
apa[0][1] += resistor[1]

### LETTER O ###############################################
for x in range(20,44):
    apa.append(Part('apa-106', 'APA-106', footprint='apa-106:APA-106-F8'))
    #Decoupling Cap
    dcap.append(Part('Device', 'CP', footprint='Capacitor_SMD:C_0805_2012Metric'))
    dcap[-1].ref = "CP" + str(x+1)
    vin += dcap[-1][1]
    gnd += dcap[-1][2]

    apa[x][2] += vin
    apa[x][3] += gnd
    # link D-In to D-Out of previous pixel
    if x > 0:
        apa[x][1] += apa[x-1][4]

resistorO = Part('Device', 'R', footprint='Resistor_SMD:R_1206_3216Metric')
resistorO[2] += apa[19][4]
apa[20][1] += resistorO[1]

### SECOND C ###############################################
for x in range(44,64):
    apa.append(Part('apa-106', 'APA-106', footprint='apa-106:APA-106-F8'))
    #Decoupling Cap
    dcap.append(Part('Device', 'CP', footprint='Capacitor_SMD:C_0805_2012Metric'))
    dcap[-1].ref = "CP" + str(x+1)
    vin += dcap[-1][1]
    gnd += dcap[-1][2]

    apa[x][2] += vin
    apa[x][3] += gnd
    # link D-In to D-Out of previous pixel
    if x > 0:
        apa[x][1] += apa[x-1][4]

resistorC = Part('Device', 'R', footprint='Resistor_SMD:R_1206_3216Metric')
resistorC[2] += apa[43][4]
apa[44][1] += resistorC[1]


### Make a cap, ground and vin for each letter
tp = []
for y in range(0,3):
	cap = Part('Device', 'CP', footprint='Capacitor_SMD:CP_Elec_6.3x7.7')
	vin += cap[1]
	gnd += cap[2]

	tp.append(Part('Connector', 'TestPoint', footprint='Connector_Wire:SolderWirePad_1x01_SMD_5x10mm'))
	tp[-1].ref = "VIN" +str(y)
	vin += tp[-1][1]

	tp.append(Part('Connector', 'TestPoint', footprint='Connector_Wire:SolderWirePad_1x01_SMD_5x10mm'))
	tp[-1].ref = "GND" +str(y)	
	gnd += tp[-1][1]


# Last one OUT
dout = Part('Connector', 'TestPoint', footprint='Connector_Wire:SolderWirePad_1x01_SMD_5x10mm')
dout.ref = "D-Out"
apa[63][4] += dout[1]

generate_netlist()